from pyinotify import WatchManager, Notifier, ThreadedNotifier, EventsCodes, ProcessEvent

class INotifyCore(ProcessEvent):

	def __init__(self, owner):
		self.owner = owner
		self.watches = []
		self.watch_manager = WatchManager()
		self.mask = EventsCodes.IN_DELETE | EventsCodes.IN_CREATE | EventsCodes.IN_MODIFY
		self.notifier = ThreadedNotifier(self.watch_manager, self)
		self.notifier.start()

	def stop(self):
		self.notifier.stop()
	
	def add_watch(self, dir):
		self.watches.append(self.watch_manager.add_watch(dir, self.mask, rec=True))

	def process_IN_CREATE(self, event):
		self.owner.fs_event(event.path, event.name, "create")

	def process_IN_DELETE(self, event):
		self.owner.fs_event(event.path, event.name, "delete")

	def process_IN_MODIFY(self, event):
		self.owner.fs_event(event.path, event.name, "modify")
